#ifndef GT_H
#define GT_H

#include "../../../libpcap/pcap-wlansniff.h"

// enables GT functionalities 
#ifndef GT_DEV
#define GT_DEV
#endif // GT_DEV

#ifdef GT_DEV

// disables multi-rate retry available in some cards
#ifndef GT_DISABLE_MRRETRY
#define GT_DISABLE_MRRETRY
#endif

// Beacon missed events are generated whenever a STA client has not
// heard a beacon from its associated for a threshold period.  Usually,
// this triggers a reassoc messages.  Enabling this flag prevents
// a STA client from issue a reassoc message.
#ifndef GT_IGNORE_BMISS
#define GT_IGNORE_BMISS
#endif

#include "../hal/ah_desc.h"
void gtif_ath_rx(struct net_device *dev, struct sk_buff *skb, struct ath_desc *ds);
#endif // GT_DEV

#define LWNG_CAP_DID_BASE   (4 | (1 << 6)) /* section 4, group 1 */

/*
 * For packet capture, define the same physical layer packet header 
 * structure as used in the wlan-ng driver 
 */
enum {
	DIDmsg_lnxind_wlansniffrm		= 0x00000044,
	DIDmsg_lnxind_wlansniffrm_hosttime	= 0x00010044,
	DIDmsg_lnxind_wlansniffrm_mactime	= 0x00020044,
	DIDmsg_lnxind_wlansniffrm_channel	= 0x00030044,
	DIDmsg_lnxind_wlansniffrm_rssi		= 0x00040044,
	DIDmsg_lnxind_wlansniffrm_sq		= 0x00050044,
	DIDmsg_lnxind_wlansniffrm_signal	= 0x00060044,
	DIDmsg_lnxind_wlansniffrm_noise		= 0x00070044,
	DIDmsg_lnxind_wlansniffrm_rate		= 0x00080044,
	DIDmsg_lnxind_wlansniffrm_istx		= 0x00090044,
	DIDmsg_lnxind_wlansniffrm_frmlen	= 0x000A0044
};
enum {
	P80211ENUM_msgitem_status_no_value	= 0x00
};
enum {
	P80211ENUM_truth_false			= 0x00
};

typedef struct {
	u_int32_t did;
	u_int16_t status;
	u_int16_t len;
	u_int32_t data;
} p80211item_uint32_t;

typedef struct {
	u_int32_t msgcode;
	u_int32_t msglen;
#define WLAN_DEVNAMELEN_MAX 16
	u_int8_t devname[WLAN_DEVNAMELEN_MAX];
	p80211item_uint32_t hosttime;
	p80211item_uint32_t mactime;
	p80211item_uint32_t channel;
	p80211item_uint32_t rssi;
	p80211item_uint32_t sq;
	p80211item_uint32_t signal;
	p80211item_uint32_t noise;
	p80211item_uint32_t rate;
	p80211item_uint32_t istx;
	p80211item_uint32_t frmlen;
} wlan_ng_prism2_header;


#endif //GT_H
